package org.dromara.personnel.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.personnel.domain.bo.OpsCaigouPlanFilesBo;
import org.dromara.personnel.domain.vo.OpsCaigouPlanFilesVo;
import org.dromara.personnel.domain.OpsCaigouPlanFiles;
import org.dromara.personnel.mapper.OpsCaigouPlanFilesMapper;
import org.dromara.personnel.service.IOpsCaigouPlanFilesService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-物资-采购申请计划文件Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-24
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsCaigouPlanFilesServiceImpl extends ServiceImpl<OpsCaigouPlanFilesMapper,OpsCaigouPlanFiles> implements IOpsCaigouPlanFilesService {

    private final OpsCaigouPlanFilesMapper baseMapper;

    /**
     * 查询运维-物资-采购申请计划文件
     *
     * @param id 主键
     * @return 运维-物资-采购申请计划文件
     */
    @Override
    public OpsCaigouPlanFilesVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-物资-采购申请计划文件列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-物资-采购申请计划文件分页列表
     */
    @Override
    public TableDataInfo<OpsCaigouPlanFilesVo> queryPageList(OpsCaigouPlanFilesBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsCaigouPlanFiles> lqw = buildQueryWrapper(bo);
        Page<OpsCaigouPlanFilesVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-物资-采购申请计划文件列表
     *
     * @param bo 查询条件
     * @return 运维-物资-采购申请计划文件列表
     */
    @Override
    public List<OpsCaigouPlanFilesVo> queryList(OpsCaigouPlanFilesBo bo) {
        LambdaQueryWrapper<OpsCaigouPlanFiles> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsCaigouPlanFiles> buildQueryWrapper(OpsCaigouPlanFilesBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsCaigouPlanFiles> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsCaigouPlanFiles::getId);
        lqw.eq(bo.getCaigouPlanId() != null, OpsCaigouPlanFiles::getCaigouPlanId, bo.getCaigouPlanId());
        lqw.eq(bo.getFileId() != null, OpsCaigouPlanFiles::getFileId, bo.getFileId());
        lqw.eq(StringUtils.isNotBlank(bo.getFileUrl()), OpsCaigouPlanFiles::getFileUrl, bo.getFileUrl());
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), OpsCaigouPlanFiles::getFileName, bo.getFileName());
        return lqw;
    }

    /**
     * 新增运维-物资-采购申请计划文件
     *
     * @param bo 运维-物资-采购申请计划文件
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsCaigouPlanFilesBo bo) {
        OpsCaigouPlanFiles add = MapstructUtils.convert(bo, OpsCaigouPlanFiles.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-物资-采购申请计划文件
     *
     * @param bo 运维-物资-采购申请计划文件
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsCaigouPlanFilesBo bo) {
        OpsCaigouPlanFiles update = MapstructUtils.convert(bo, OpsCaigouPlanFiles.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsCaigouPlanFiles entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-物资-采购申请计划文件信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public List<OpsCaigouPlanFilesVo> getVoByCaiGouPlanId(Long caigouId) {
        return baseMapper.selectVoList(new LambdaQueryWrapper<OpsCaigouPlanFiles>().eq(OpsCaigouPlanFiles::getCaigouPlanId, caigouId));
    }
}
